/*
 * Copyright (C) 2022 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

syntax = "proto2";

package android.healthfitness.ui;

option java_outer_classname = "HealthConnectUiEnums";
option java_multiple_files = true;

enum ElementId {

    // Deprecated enum values
    reserved 115, 116, 135, 136;

    ELEMENT_UNKNOWN = 0;

    // Home page
    APP_PERMISSIONS_BUTTON = 1;
    DATA_AND_ACCESS_BUTTON = 2;
    SEE_ALL_RECENT_ACCESS_BUTTON = 3;
    RECENT_ACCESS_ENTRY = 4;
    MANAGE_DATA_BUTTON = 153;

    // Onboarding page
    ONBOARDING_COMPLETED_BUTTON = 6;
    ONBOARDING_GO_BACK_BUTTON = 7;

    // Recent access page
    MANAGE_PERMISSIONS_FLOATING_BUTTON = 8;

    // App permissions page
    SEARCH_BUTTON = 9;
    CONNECTED_APP_BUTTON = 10;
    NOT_CONNECTED_APP_BUTTON = 11;
    INACTIVE_APP_BUTTON = 187;
    INACTIVE_APP_DELETE_BUTTON = 12;
    REMOVE_ALL_APPS_PERMISSIONS_BUTTON = 13;
    HELP_AND_FEEDBACK_BUTTON = 14;
    SEND_FEEDBACK_BUTTON = 188;

    // App permissions empty state & Help and feedback page
    CHECK_FOR_UPDATES_BUTTON = 15;
    SEE_ALL_COMPATIBLE_APPS_BUTTON = 16;

    // Inactive app dialog from app permissions
    INACTIVE_APP_DIALOG_CONTAINER = 18;
    INACTIVE_APP_DIALOG_REMOVE_PERMISSIONS_BUTTON = 19;
    INACTIVE_APP_DIALOG_GO_BACK_BUTTON = 20;
    INACTIVE_APP_DIALOG_DELETE_BUTTON = 21;

    // Denied apps
    DENIED_APPS_BANNER = 22;
    DENIED_APPS_SEE_DETAILS_BUTTON = 23;
    DENIED_APPS_DIALOG_CONTAINER = 24;
    DENIED_APPS_DIALOG_GOT_IT_BUTTON = 25;
    APP_DENIED_DIALOG_CONTAINER = 26;
    APP_DENIED_DIALOG_GOT_IT_BUTTON = 27;

    // Blocked app dialog
    BLOCKED_APP_DIALOG_CONTAINER = 28;
    BLOCKED_APP_DIALOG_GOT_IT_BUTTON = 29;

    // Categories page
    CATEGORY_BUTTON = 30;
    SEE_ALL_CATEGORIES_BUTTON = 31;
    EXPORT_DATA_BUTTON = 32;
    AUTO_DELETE_BUTTON = 33;
    DELETE_ALL_DATA_BUTTON = 34;

    // Auto-delete page
    AUTO_DELETE_THREE_MONTHS_BUTTON = 35;
    AUTO_DELETE_EIGHTEEN_MONTHS_BUTTON = 36;
    AUTO_DELETE_NEVER_BUTTON = 37;

    // Auto-delete dialog
    AUTO_DELETE_DIALOG_CONTAINER = 38;
    AUTO_DELETE_DIALOG_CANCEL_BUTTON = 39;
    AUTO_DELETE_DIALOG_CONFIRM_BUTTON = 40;
    AUTO_DELETE_CONFIRMATION_DIALOG_CONTAINER = 41;
    AUTO_DELETE_CONFIRMATION_DIALOG_DONE_BUTTON = 42;

    // Permission types page
    APP_FILTER_BUTTON = 43;
    PERMISSION_TYPE_BUTTON = 44;
    SET_APP_PRIORITY_BUTTON = 45;
    DELETE_CATEGORY_DATA_BUTTON = 46;

    // Data access page
    DATA_ACCESS_APP_BUTTON = 47;
    DATA_ACCESS_INACTIVE_APP_BUTTON = 48;
    SEE_ALL_ENTRIES_BUTTON = 49;
    DELETE_THIS_DATA_BUTTON = 50;

    // Data entries page
    AGGREGATION_DATA_VIEW = 51;
    DATA_ENTRY_VIEW = 52;
    DATA_ENTRY_DELETE_BUTTON = 117;
    EXERCISE_SESSION_ENTRY_BUTTON = 53;
    SLEEP_SESSION_ENTRY_BUTTON = 118;
    NEXT_DAY_BUTTON = 54;
    PREVIOUS_DAY_BUTTON = 55;
    SELECT_DATE_BUTTON = 56;
    EXERCISE_SESSION_MAP_VIEW = 186;
    PLANNED_EXERCISE_SESSION_ENTRY_BUTTON = 209;

    // Entry details
    EXERCISE_SESSION_ENTRY_DETAILS_VIEW = 119;
    SLEEP_SESSION_ENTRY_DETAILS_VIEW = 120;
    SESSION_DETAIL_ENTRY_VIEW = 121;
    SESSION_DETAIL_HEADER_VIEW = 122;
    REVERSE_SESSION_DETAIL_ENTRY_VIEW = 196;
    FORMATTED_SECTION_TITLE_VIEW = 197;
    FORMATTED_SECTION_CONTENT_VIEW = 207;
    EXERCISE_PERFORMANCE_GOAL_ENTRY_VIEW = 208;
    PLANNED_EXERCISE_BLOCK_ENTRY_VIEW = 210;
    PLANNED_EXERCISE_STEP_ENTRY_VIEW = 211;

    // Units
    CHANGE_UNITS_HEIGHT_BUTTON = 57;
    CHANGE_UNITS_WEIGHT_BUTTON = 58;
    CHANGE_UNITS_DISTANCE_BUTTON = 59;
    CHANGE_UNITS_ENERGY_BUTTON = 60;
    CHANGE_UNITS_TEMPERATURE_BUTTON = 61;

    // Units dialog
    CANCEL_BUTTON = 62;
    // Height
    CENTIMETERS_BUTTON = 63;
    FEET_AND_INCHES_BUTTON = 64;
    // Weight
    KILOGRAMS_BUTTON = 65;
    POUNDS_BUTTON = 66;
    STONES_BUTTON = 67;
    // Distance
    KILOMETERS_BUTTON = 68;
    MILES_BUTTON = 69;
    // Energy
    CALORIES_BUTTON = 70;
    KILOJOULES_BUTTON = 71;
    // Temperature
    CELSIUS_BUTTON = 72;
    FAHRENHEIT_BUTTON = 73;
    KELVIN_BUTTON = 74;

    // App access
    ALLOW_ALL_PERMISSIONS_SWITCH_ACTIVE = 75;
    ALLOW_ALL_PERMISSIONS_SWITCH_INACTIVE = 76;
    PERMISSION_SWITCH_ACTIVE = 77;
    PERMISSION_SWITCH_INACTIVE = 78;
    DELETE_APP_DATA_BUTTON = 79;
    PRIVACY_POLICY_LINK = 80;
    ADDITIONAL_ACCESS_BUTTON = 175;

    // Disconnect app dialog
    DISCONNECT_APP_DIALOG_CONTAINER = 81;
    DISCONNECT_APP_DIALOG_CANCEL_BUTTON = 82;
    DISCONNECT_APP_DIALOG_CONFIRM_BUTTON = 83;
    DISCONNECT_APP_DIALOG_DELETE_CHECKBOX = 84;

    // Disconnect all apps dialog
    DISCONNECT_ALL_APPS_DIALOG_CONTAINER = 85;
    DISCONNECT_ALL_APPS_DIALOG_CANCEL_BUTTON = 86;
    DISCONNECT_ALL_APPS_DIALOG_REMOVE_ALL_BUTTON = 87;

    // Request permissions
    ALLOW_PERMISSIONS_BUTTON = 88;
    CANCEL_PERMISSIONS_BUTTON = 89;
    ALLOW_ALL_SWITCH = 90;
    PERMISSION_SWITCH = 91;
    APP_RATIONALE_LINK = 92;

    // Request additional permissions
    ALLOW_COMBINED_ADDITIONAL_PERMISSIONS_BUTTON = 198;
    CANCEL_COMBINED_ADDITIONAL_PERMISSIONS_BUTTON = 199;
    ALLOW_BACKGROUND_READ_BUTTON = 200;
    CANCEL_BACKGROUND_READ_BUTTON = 201;
    ALLOW_HISTORY_READ_BUTTON = 202;
    CANCEL_HISTORY_READ_BUTTON = 203;


    // Exercise routes dialogs
    EXERCISE_ROUTE_DIALOG_CONTAINER = 123;
    EXERCISE_ROUTE_DIALOG_INFORMATION_BUTTON = 124;
    EXERCISE_ROUTE_DIALOG_ROUTE_VIEW = 125;
    EXERCISE_ROUTE_DIALOG_ALLOW_BUTTON = 126;
    EXERCISE_ROUTE_DIALOG_ALWAYS_ALLOW_BUTTON = 195;
    EXERCISE_ROUTE_DIALOG_DONT_ALLOW_BUTTON = 127;
    EXERCISE_ROUTE_EDUCATION_DIALOG_CONTAINER = 128;
    EXERCISE_ROUTE_EDUCATION_DIALOG_BACK_BUTTON = 129;

    // Deletion dialogs
    // Deletion time range dialog
    DELETION_DIALOG_TIME_RANGE_CONTAINER = 93;
    DELETION_DIALOG_TIME_RANGE_LAST_24_HOURS_BUTTON = 94;
    DELETION_DIALOG_TIME_RANGE_LAST_7_DAYS_BUTTON = 95;
    DELETION_DIALOG_TIME_RANGE_LAST_30_DAYS_BUTTON = 96;
    DELETION_DIALOG_TIME_RANGE_ALL_DATA_BUTTON = 97;
    DELETION_DIALOG_TIME_RANGE_CANCEL_BUTTON = 98;
    DELETION_DIALOG_TIME_RANGE_NEXT_BUTTON = 99;
    // Deletion confirmation dialog
    DELETION_DIALOG_CONFIRMATION_CONTAINER = 100;
    DELETION_DIALOG_CONFIRMATION_GO_BACK_BUTTON = 101;
    DELETION_DIALOG_CONFIRMATION_CANCEL_BUTTON = 102;
    DELETION_DIALOG_CONFIRMATION_DELETE_BUTTON = 103;
    DELETION_DIALOG_CONFIRMATION_REMOVE_APP_PERMISSIONS_BUTTON = 104;
    // Deletion in progress
    DELETION_DIALOG_IN_PROGRESS_CONTAINER = 105;
    // Deletion done
    DELETION_DIALOG_SUCCESS_CONTAINER = 106;
    DELETION_DIALOG_SUCCESS_DONE_BUTTON = 107;
    // Deletion error
    DELETION_DIALOG_ERROR_CONTAINER = 108;
    DELETION_DIALOG_ERROR_CLOSE_BUTTON = 109;
    DELETION_DIALOG_ERROR_TRY_AGAIN_BUTTON = 110;

    // Toolbar overflow
    TOOLBAR_HELP_BUTTON = 111;
    TOOLBAR_SETTINGS_BUTTON = 113;
    TOOLBAR_OPEN_SOURCE_LICENSE_BUTTON = 114;

    // App priority dialog
    SET_APP_PRIORITY_DIALOG_CONTAINER = 130;
    SET_APP_PRIORITY_DIALOG_CANCEL_BUTTON = 131;
    SET_APP_PRIORITY_DIALOG_SAVE_BUTTON = 132;

    // Migration
    MIGRATION_UPDATE_NEEDED_UPDATE_BUTTON = 133;
    MIGRATION_UPDATE_NEEDED_CANCEL_BUTTON = 134;
    MIGRATION_PAUSED_CONTINUE_BUTTON = 184;
    MIGRATION_PAUSED_CANCEL_BUTTON = 185;
    MIGRATION_DONE_DIALOG_CONTAINER = 137;
    MIGRATION_DONE_DIALOG_BUTTON = 138;
    MIGRATION_IN_PROGRESS_DIALOG_CONTAINER = 139;
    MIGRATION_IN_PROGRESS_DIALOG_BUTTON = 140;
    MIGRATION_PENDING_DIALOG_CONTAINER = 141;
    MIGRATION_PENDING_DIALOG_CANCEL_BUTTON = 142;
    MIGRATION_PENDING_DIALOG_CONTINUE_BUTTON = 143;
    MIGRATION_NOT_COMPLETE_DIALOG_CONTAINER = 144;
    MIGRATION_NOT_COMPLETE_DIALOG_BUTTON = 145;

    MIGRATION_RESUME_BANNER = 146;
    MIGRATION_RESUME_BANNER_BUTTON = 147;
    MIGRATION_APP_UPDATE_BANNER = 148;
    // Banner buttons
    MIGRATION_APP_UPDATE_BUTTON = 149;
    MIGRATION_APP_UPDATE_LEARN_MORE_BUTTON = 174;
    MIGRATION_APP_UPDATE_APP_BUTTON = 173;
    MIGRATION_APP_UPDATE_DISMISS_BUTTON = 181;

    // Data restore
    DATA_RESTORE_UPDATE_NEEDED_BANNER = 164;
    DATA_RESTORE_UPDATE_NEEDED_BANNER_UPDATE_BUTTON = 165;
    DATA_RESTORE_UPDATE_NEEDED_CANCEL_RESTORE_BUTTON = 166;
    DATA_RESTORE_FAILED_BANNER = 167;
    DATA_RESTORE_FAILED_BANNER_BUTTON = 168;
    DATA_RESTORE_CANCEL_DIALOG = 169;
    DATA_RESTORE_CANCEL_DIALOG_CANCEL_BUTTON = 170;
    DATA_RESTORE_CANCEL_DIALOG_CONTINUE_BUTTON = 171;
    DATA_RESTORE_SUCCESS_SNACKBAR = 172;
    DATA_RESTORE_IN_PROGRESS_DIALOG_CONTAINER = 182;
    DATA_RESTORE_IN_PROGRESS_DIALOG_BUTTON = 183;

    // Loading and error page states
    LOADING_PAGE_STATE = 150;
    ERROR_PAGE_STATE = 151;
    WITH_DATA_PAGE_STATE = 152;

    // Manage data page
    BACKUP_DATA_BUTTON = 5;
    DATA_SOURCES_AND_PRIORITY_BUTTON = 154;
    SET_UNITS_BUTTON = 155;

    // Data sources page
    DATA_TYPE_SPINNER_BUTTON = 156;
    DATA_TOTALS_CARD = 157;
    APP_SOURCE_BUTTON = 158;
    ADD_AN_APP_BUTTON = 159;
    EDIT_SOURCE_LIST_BUTTON = 160;
    REORDER_APP_SOURCE_BUTTON = 162;
    REMOVE_APP_SOURCE_BUTTON = 163;

    // Add an app page
    POTENTIAL_PRIORITY_APP_BUTTON = 161;

    // Additional Access page
    EXERCISE_ROUTES_BUTTON = 176;
    EXERCISE_ROUTES_DIALOG_CONTAINER = 180;
    EXERCISE_ROUTES_DIALOG_ALLOW_ALL_BUTTON = 177;
    EXERCISE_ROUTES_DIALOG_ASK_BUTTON  = 178;
    EXERCISE_ROUTES_DIALOG_DENY_BUTTON  = 179;
    ENABLE_EXERCISE_PERMISSION_DIALOG_CONTAINER = 189;
    ENABLE_EXERCISE_PERMISSION_DIALOG_POSITIVE_BUTTON = 190;
    ENABLE_EXERCISE_PERMISSION_DIALOG_NEGATIVE_BUTTON = 191;
    DISABLE_EXERCISE_PERMISSION_DIALOG_CONTAINER = 192;
    DISABLE_EXERCISE_PERMISSION_DIALOG_POSITIVE_BUTTON = 193;
    DISABLE_EXERCISE_PERMISSION_DIALOG_NEGATIVE_BUTTON = 194;
    BACKGROUND_READ_BUTTON = 204;
    HISTORY_READ_BUTTON = 205;

    // Next available: 212;

}

enum PageId {

    // Deprecated enum values
    reserved 17, 18, 24;

    PAGE_UNKNOWN = 0;
    HOME_PAGE = 1;
    ONBOARDING_PAGE = 2;
    RECENT_ACCESS_PAGE = 3;
    APP_PERMISSIONS_PAGE = 4;
    APP_PERMISSIONS_EMPTY_STATE_PAGE = 5;
    HELP_AND_FEEDBACK_PAGE = 6;
    CATEGORIES_PAGE = 7;
    AUTO_DELETE_PAGE = 8;
    PERMISSION_TYPES_PAGE = 9;
    DATA_ACCESS_PAGE = 10;
    DATA_ENTRIES_PAGE = 11;
    ENTRY_DETAILS_PAGE = 12;
    APP_ACCESS_PAGE = 13;
    UNITS_PAGE = 14;
    ALL_CATEGORIES_PAGE = 15;
    REQUEST_PERMISSIONS_PAGE = 16;
    REQUEST_COMBINED_ADDITIONAL_PERMISSIONS_PAGE = 33;
    REQUEST_BACKGROUND_READ_PERMISSION_PAGE = 34;
    REQUEST_HISTORY_READ_PERMISSION_PAGE = 35;
    // ERROR_PAGE = 17;
    // LOADING_PAGE = 18;
    MANAGE_PERMISSIONS_PAGE = 19;
    SETTINGS_MANAGE_PERMISSIONS_PAGE = 20;
    SETTINGS_MANAGE_APP_PERMISSIONS_PAGE = 31;
    // Migration UI
    MIGRATION_IN_PROGRESS_PAGE = 21;
    MIGRATION_APP_UPDATE_NEEDED_PAGE = 22;
    MIGRATION_MODULE_UPDATE_NEEDED_PAGE = 23;
    MIGRATION_PAUSED_PAGE = 25;
    // New IA and Source controls
    MANAGE_DATA_PAGE = 26;
    DATA_SOURCES_PAGE = 27;
    ADD_AN_APP_PAGE = 28;
    DATA_RESTORE_IN_PROGRESS_PAGE = 29;
    // Additional Access
    ADDITIONAL_ACCESS_PAGE = 30;
    SEARCH_APPS_PAGE = 32;

    // Next available: 36;
}

enum Action {
    ACTION_UNKNOWN = 0;
    ACTION_CLICK = 1;
    ACTION_TOGGLE_ON = 2;
    ACTION_TOGGLE_OFF = 3;
}

enum Source {
    SOURCE_UNKNOWN_ENTRY_POINT = 0;
    SOURCE_DEEP_LINK = 1;
    SOURCE_DYNAMIC_SETTINGS = 2;
    SOURCE_QUICK_SETTINGS = 3;
    SOURCE_MAIN_ACTION = 4;
}
